package cn.ibizlab.core.sample.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import org.springframework.util.Assert;
import cn.ibizlab.util.domain.EntityBase;
import cn.ibizlab.util.annotation.DEField;
import cn.ibizlab.util.enums.DEPredefinedFieldType;
import cn.ibizlab.util.enums.DEFieldDefaultValueType;
import cn.ibizlab.util.helper.DataObject;
import cn.ibizlab.util.annotation.Audit;
import cn.ibizlab.util.enums.DupCheck;
import cn.ibizlab.util.domain.EntityMP;
import java.io.Serializable;
import lombok.*;
import lombok.experimental.Accessors;
import org.springframework.data.annotation.Transient;
import org.springframework.data.annotation.Id;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;

@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "T_IBIZQJ", resultMap = "IBIZQJResultMap")
@ApiModel(value = "IBIZQJ", description = "请假")
public class IBIZQJ extends EntityMP implements Serializable
{

    /**
     * 更新时间
     */
    @TableField(value = "updatedate")
    @DEField(name = "updatedate" , preType = DEPredefinedFieldType.UPDATEDATE)
    @JsonProperty("updatedate")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", locale = "zh", timezone = "GMT+8")
    @JSONField(name = "updatedate" , format = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "updatedate", notes = "更新时间")
    private Timestamp updateDate;

    /**
     * 建立时间
     */
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @DEField(name = "createdate" , preType = DEPredefinedFieldType.CREATEDATE)
    @JsonProperty("createdate")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", locale = "zh", timezone = "GMT+8")
    @JSONField(name = "createdate" , format = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "createdate", notes = "建立时间")
    private Timestamp createDate;

    /**
     * 建立人
     */
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @DEField(name = "createman" , preType = DEPredefinedFieldType.CREATEMAN , dict = "SysOperator")
    @JsonProperty("createman")
    @JSONField(name = "createman")
    @ApiModelProperty(value = "createman", notes = "建立人")
    private String createMan;

    /**
     * 请假名称
     */
    @TableField(value = "ibizqjname")
    @DEField(name = "ibizqjname")
    @JsonProperty("ibizqjname")
    @JSONField(name = "ibizqjname")
    @ApiModelProperty(value = "ibizqjname", notes = "请假名称")
    private String ibizqjName;

    /**
     * 请假标识
     */
    @Id
    @TableId(value = "ibizqjid" , type = IdType.ASSIGN_UUID)
    @DEField(name = "ibizqjid" , isKeyField = true)
    @JsonProperty("ibizqjid")
    @JSONField(name = "ibizqjid")
    @ApiModelProperty(value = "ibizqjid", notes = "请假标识")
    private String ibizqjid;

    /**
     * 请假天数
     */
    @TableField(value = "qjts")
    @DEField(name = "qjts")
    @JsonProperty("qjts")
    @JSONField(name = "qjts")
    @ApiModelProperty(value = "qjts", notes = "请假天数")
    private Integer qjts;

    /**
     * 更新人
     */
    @TableField(value = "updateman")
    @DEField(name = "updateman" , preType = DEPredefinedFieldType.UPDATEMAN , dict = "SysOperator")
    @JsonProperty("updateman")
    @JSONField(name = "updateman")
    @ApiModelProperty(value = "updateman", notes = "更新人")
    private String updateMan;

    /**
     * 剩余请假天数
     */
    @TableField(value = "syqjts")
    @DEField(name = "syqjts" , defaultValue = "10")
    @JsonProperty("syqjts")
    @JSONField(name = "syqjts")
    @ApiModelProperty(value = "syqjts", notes = "剩余请假天数")
    private Integer syqjts;







    /**
     * 设置 [请假名称]
     */
    public void setIbizqjName(String ibizqjName) {
        this.ibizqjName = ibizqjName;
        this.modify("ibizqjname", ibizqjName);
    }


    /**
     * 设置 [请假天数]
     */
    public void setQjts(Integer qjts) {
        this.qjts = qjts;
        this.modify("qjts", qjts);
    }


    /**
     * 设置 [剩余请假天数]
     */
    public void setSyqjts(Integer syqjts) {
        this.syqjts = syqjts;
        this.modify("syqjts", syqjts);
    }



    

    /**
     * 复制当前对象数据到目标对象(粘贴重置)
     * @param targetEntity 目标数据对象
     * @param bIncEmpty  是否包括空值
     * @param <T>
     * @return
     */
    @Override
    public <T> T copyTo(T targetEntity, boolean bIncEmpty) {
        this.reset("ibizqjid");        
        return super.copyTo(targetEntity, bIncEmpty);
    }    
}