package cn.ibizlab.core.sample.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import org.springframework.util.Assert;
import cn.ibizlab.util.domain.EntityBase;
import cn.ibizlab.util.annotation.DEField;
import cn.ibizlab.util.enums.DEPredefinedFieldType;
import cn.ibizlab.util.enums.DEFieldDefaultValueType;
import cn.ibizlab.util.helper.DataObject;
import cn.ibizlab.util.annotation.Audit;
import cn.ibizlab.util.enums.DupCheck;
import cn.ibizlab.util.domain.EntityMP;
import java.io.Serializable;
import lombok.*;
import lombok.experimental.Accessors;
import org.springframework.data.annotation.Transient;
import org.springframework.data.annotation.Id;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import cn.ibizlab.core.sample.domain.IBIZSample0019;

@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "T_IBIZSAMPLE0020", resultMap = "IBIZSample0020ResultMap")
@ApiModel(value = "IBIZSAMPLE0020", description = "员工")
public class IBIZSample0020 extends EntityMP implements Serializable
{

    /**
     * 员工名称
     */
    @TableField(value = "ibizsample0020name")
    @DEField(name = "ibizsample0020name")
    @JsonProperty("ibizsample0020name")
    @JSONField(name = "ibizsample0020name")
    @ApiModelProperty(value = "ibizsample0020name", notes = "员工名称")
    private String ibizsample0020Name;

    /**
     * 建立时间
     */
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @DEField(name = "createdate" , preType = DEPredefinedFieldType.CREATEDATE)
    @JsonProperty("createdate")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", locale = "zh", timezone = "GMT+8")
    @JSONField(name = "createdate" , format = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "createdate", notes = "建立时间")
    private Timestamp createDate;

    /**
     * 员工标识
     */
    @Id
    @TableId(value = "ibizsample0020id" , type = IdType.ASSIGN_UUID)
    @DEField(name = "ibizsample0020id" , isKeyField = true)
    @JsonProperty("ibizsample0020id")
    @JSONField(name = "ibizsample0020id")
    @ApiModelProperty(value = "ibizsample0020id", notes = "员工标识")
    private String ibizsample0020Id;

    /**
     * 更新时间
     */
    @TableField(value = "updatedate")
    @DEField(name = "updatedate" , preType = DEPredefinedFieldType.UPDATEDATE)
    @JsonProperty("updatedate")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", locale = "zh", timezone = "GMT+8")
    @JSONField(name = "updatedate" , format = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "updatedate", notes = "更新时间")
    private Timestamp updateDate;

    /**
     * 建立人
     */
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @DEField(name = "createman" , preType = DEPredefinedFieldType.CREATEMAN , dict = "SysOperator")
    @JsonProperty("createman")
    @JSONField(name = "createman")
    @ApiModelProperty(value = "createman", notes = "建立人")
    private String createMan;

    /**
     * 更新人
     */
    @TableField(value = "updateman")
    @DEField(name = "updateman" , preType = DEPredefinedFieldType.UPDATEMAN , dict = "SysOperator")
    @JsonProperty("updateman")
    @JSONField(name = "updateman")
    @ApiModelProperty(value = "updateman", notes = "更新人")
    private String updateMan;

    /**
     * 部门名称
     */
    @TableField(value = "ibizsample0019name")
    @DEField(name = "ibizsample0019name")
    @JsonProperty("ibizsample0019name")
    @JSONField(name = "ibizsample0019name")
    @ApiModelProperty(value = "ibizsample0019name", notes = "部门名称")
    private String ibizsample0019Name;

    /**
     * 部门id
     */
    @TableField(value = "ibizsample0019id")
    @DEField(name = "ibizsample0019id")
    @JsonProperty("ibizsample0019id")
    @JSONField(name = "ibizsample0019id")
    @ApiModelProperty(value = "ibizsample0019id", notes = "部门id")
    private String ibizsample0019Id;


    /**
     * 部门
     */
    @JsonIgnore
    @JSONField(serialize = false)
    @TableField(exist = false)
    @ApiModelProperty(value = "ibizsample0019", notes = "")
    private IBIZSample0019 ibizsample0019;


    /**
     * 设置 [员工名称]
     */
    public void setIbizsample0020Name(String ibizsample0020Name) {
        this.ibizsample0020Name = ibizsample0020Name;
        this.modify("ibizsample0020name", ibizsample0020Name);
    }






    /**
     * 设置 [部门名称]
     */
    public void setIbizsample0019Name(String ibizsample0019Name) {
        this.ibizsample0019Name = ibizsample0019Name;
        this.modify("ibizsample0019name", ibizsample0019Name);
    }

    /**
     * 设置 [部门id]
     */
    public void setIbizsample0019Id(String ibizsample0019Id) {
        this.ibizsample0019Id = ibizsample0019Id;
        this.modify("ibizsample0019id", ibizsample0019Id);
    }



    

    /**
     * 复制当前对象数据到目标对象(粘贴重置)
     * @param targetEntity 目标数据对象
     * @param bIncEmpty  是否包括空值
     * @param <T>
     * @return
     */
    @Override
    public <T> T copyTo(T targetEntity, boolean bIncEmpty) {
        this.reset("ibizsample0020id");        
        return super.copyTo(targetEntity, bIncEmpty);
    }    
}