package cn.ibizlab.core.sample.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import org.springframework.util.Assert;
import cn.ibizlab.util.domain.EntityBase;
import cn.ibizlab.util.annotation.DEField;
import cn.ibizlab.util.enums.DEPredefinedFieldType;
import cn.ibizlab.util.enums.DEFieldDefaultValueType;
import cn.ibizlab.util.helper.DataObject;
import cn.ibizlab.util.annotation.Audit;
import cn.ibizlab.util.enums.DupCheck;
import cn.ibizlab.util.domain.EntityMP;
import java.io.Serializable;
import lombok.*;
import lombok.experimental.Accessors;
import org.springframework.data.annotation.Transient;
import org.springframework.data.annotation.Id;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;

@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "T_IBIZSAMPLE0021", resultMap = "IBIZSample0021ResultMap")
@ApiModel(value = "IBIZSAMPLE0021", description = "订单")
public class IBIZSample0021 extends EntityMP implements Serializable
{

    /**
     * 订单标识
     */
    @Id
    @TableId(value = "ibizsample0021id" , type = IdType.ASSIGN_UUID)
    @DEField(name = "ibizsample0021id" , isKeyField = true)
    @JsonProperty("ibizsample0021id")
    @JSONField(name = "ibizsample0021id")
    @ApiModelProperty(value = "ibizsample0021id", notes = "订单标识")
    private String ibizSample0021Id;

    /**
     * 建立人
     */
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @DEField(name = "createman" , preType = DEPredefinedFieldType.CREATEMAN , dict = "SysOperator")
    @JsonProperty("createman")
    @JSONField(name = "createman")
    @ApiModelProperty(value = "createman", notes = "建立人")
    private String createMan;

    /**
     * 建立时间
     */
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @DEField(name = "createdate" , preType = DEPredefinedFieldType.CREATEDATE)
    @JsonProperty("createdate")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", locale = "zh", timezone = "GMT+8")
    @JSONField(name = "createdate" , format = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "createdate", notes = "建立时间")
    private Timestamp createDate;

    /**
     * 订单名称
     */
    @TableField(value = "ibizsample0021name")
    @DEField(name = "ibizsample0021name")
    @JsonProperty("ibizsample0021name")
    @JSONField(name = "ibizsample0021name")
    @ApiModelProperty(value = "ibizsample0021name", notes = "订单名称")
    private String ibizSample0021Name;

    /**
     * 更新人
     */
    @TableField(value = "updateman")
    @DEField(name = "updateman" , preType = DEPredefinedFieldType.UPDATEMAN , dict = "SysOperator")
    @JsonProperty("updateman")
    @JSONField(name = "updateman")
    @ApiModelProperty(value = "updateman", notes = "更新人")
    private String updateMan;

    /**
     * 更新时间
     */
    @TableField(value = "updatedate")
    @DEField(name = "updatedate" , preType = DEPredefinedFieldType.UPDATEDATE)
    @JsonProperty("updatedate")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", locale = "zh", timezone = "GMT+8")
    @JSONField(name = "updatedate" , format = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "updatedate", notes = "更新时间")
    private Timestamp updateDate;

    /**
     * 订单状态
     */
    @TableField(value = "orderstate")
    @DEField(name = "orderstate" , defaultValue = "10" , dict = "ORDERSTATE")
    @JsonProperty("orderstate")
    @JSONField(name = "orderstate")
    @ApiModelProperty(value = "orderstate", notes = "订单状态")
    private String orderState;

    /**
     * 订单时间
     */
    @TableField(value = "ordertime")
    @DEField(name = "ordertime")
    @JsonProperty("ordertime")
    @JsonFormat(pattern = "yyyy-MM-dd", locale = "zh", timezone = "GMT+8")
    @JSONField(name = "ordertime" , format = "yyyy-MM-dd")
    @ApiModelProperty(value = "ordertime", notes = "订单时间")
    private Timestamp orderTime;

    /**
     * 备注
     */
    @TableField(value = "memo")
    @DEField(name = "memo")
    @JsonProperty("memo")
    @JSONField(name = "memo")
    @ApiModelProperty(value = "memo", notes = "备注")
    private String memo;

    /**
     * CURORGID
     */
    @TableField(value = "curorgid")
    @DEField(name = "curorgid" , preType = DEPredefinedFieldType.ORGID)
    @JsonProperty("curorgid")
    @JSONField(name = "curorgid")
    @ApiModelProperty(value = "curorgid", notes = "CURORGID")
    private String curorgid;

    /**
     * CURDEPTID
     */
    @TableField(value = "curdeptid")
    @DEField(name = "curdeptid" , preType = DEPredefinedFieldType.ORGSECTORID)
    @JsonProperty("curdeptid")
    @JSONField(name = "curdeptid")
    @ApiModelProperty(value = "curdeptid", notes = "CURDEPTID")
    private String curdeptid;

    /**
     * 总计
     */
    @TableField(value = "amount")
    @DEField(name = "amount")
    @JsonProperty("amount")
    @JSONField(name = "amount")
    @ApiModelProperty(value = "amount", notes = "总计")
    private BigDecimal amount;

    /**
     * 部门领导
     */
    @TableField(value = "deptheads" , exist = false)
    @DEField(name = "deptheads")
    @JsonProperty("deptheads")
    @JSONField(name = "deptheads")
    @ApiModelProperty(value = "deptheads", notes = "部门领导")
    private String deptHeads;

    /**
     * 部门领导
     */
    @TableField(value = "deptheadsid" , exist = false)
    @DEField(name = "deptheadsid")
    @JsonProperty("deptheadsid")
    @JSONField(name = "deptheadsid")
    @ApiModelProperty(value = "deptheadsid", notes = "部门领导")
    private String deptHeadsId;







    /**
     * 设置 [订单名称]
     */
    public void setIbizSample0021Name(String ibizSample0021Name) {
        this.ibizSample0021Name = ibizSample0021Name;
        this.modify("ibizsample0021name", ibizSample0021Name);
    }



    /**
     * 设置 [订单状态]
     */
    public void setOrderState(String orderState) {
        this.orderState = orderState;
        this.modify("orderstate", orderState);
    }

    /**
     * 设置 [订单时间]
     */
    public void setOrderTime(Timestamp orderTime) {
        this.orderTime = orderTime;
        this.modify("ordertime", orderTime);
    }

    /**
     * 设置 [备注]
     */
    public void setMemo(String memo) {
        this.memo = memo;
        this.modify("memo", memo);
    }



    /**
     * 设置 [总计]
     */
    public void setAmount(BigDecimal amount) {
        this.amount = amount;
        this.modify("amount", amount);
    }

    /**
     * 设置 [部门领导]
     */
    public void setDeptHeads(String deptHeads) {
        this.deptHeads = deptHeads;
        this.modify("deptheads", deptHeads);
    }

    /**
     * 设置 [部门领导]
     */
    public void setDeptHeadsId(String deptHeadsId) {
        this.deptHeadsId = deptHeadsId;
        this.modify("deptheadsid", deptHeadsId);
    }



    

    /**
     * 复制当前对象数据到目标对象(粘贴重置)
     * @param targetEntity 目标数据对象
     * @param bIncEmpty  是否包括空值
     * @param <T>
     * @return
     */
    @Override
    public <T> T copyTo(T targetEntity, boolean bIncEmpty) {
        this.reset("ibizsample0021id");        
        return super.copyTo(targetEntity, bIncEmpty);
    }    
}