package cn.ibizlab.core.sample.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import org.springframework.util.Assert;
import cn.ibizlab.util.domain.EntityBase;
import cn.ibizlab.util.annotation.DEField;
import cn.ibizlab.util.enums.DEPredefinedFieldType;
import cn.ibizlab.util.enums.DEFieldDefaultValueType;
import cn.ibizlab.util.helper.DataObject;
import cn.ibizlab.util.annotation.Audit;
import cn.ibizlab.util.enums.DupCheck;
import cn.ibizlab.util.domain.EntityMP;
import java.io.Serializable;
import lombok.*;
import lombok.experimental.Accessors;
import org.springframework.data.annotation.Transient;
import org.springframework.data.annotation.Id;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import cn.ibizlab.core.sample.domain.IBIZTASKTEAM;

@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "T_IBIZTASK", resultMap = "IBIZTASKResultMap")
@ApiModel(value = "IBIZTASK", description = "任务")
public class IBIZTASK extends EntityMP implements Serializable
{

    /**
     * 任务标识
     */
    @Id
    @TableId(value = "ibiztaskid" , type = IdType.ASSIGN_UUID)
    @DEField(name = "ibiztaskid" , isKeyField = true)
    @JsonProperty("ibiztaskid")
    @JSONField(name = "ibiztaskid")
    @ApiModelProperty(value = "ibiztaskid", notes = "任务标识")
    private String ibiztaskid;

    /**
     * 更新时间
     */
    @TableField(value = "updatedate")
    @DEField(name = "updatedate" , preType = DEPredefinedFieldType.UPDATEDATE)
    @JsonProperty("updatedate")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", locale = "zh", timezone = "GMT+8")
    @JSONField(name = "updatedate" , format = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "updatedate", notes = "更新时间")
    private Timestamp updateDate;

    /**
     * 任务名称
     */
    @TableField(value = "ibiztaskname")
    @DEField(name = "ibiztaskname")
    @JsonProperty("ibiztaskname")
    @JSONField(name = "ibiztaskname")
    @ApiModelProperty(value = "ibiztaskname", notes = "任务名称")
    private String ibiztaskName;

    /**
     * 建立人
     */
    @TableField(value = "createman" , fill = FieldFill.INSERT)
    @DEField(name = "createman" , preType = DEPredefinedFieldType.CREATEMAN , dict = "SysOperator")
    @JsonProperty("createman")
    @JSONField(name = "createman")
    @ApiModelProperty(value = "createman", notes = "建立人")
    private String createMan;

    /**
     * 更新人
     */
    @TableField(value = "updateman")
    @DEField(name = "updateman" , preType = DEPredefinedFieldType.UPDATEMAN , dict = "SysOperator")
    @JsonProperty("updateman")
    @JSONField(name = "updateman")
    @ApiModelProperty(value = "updateman", notes = "更新人")
    private String updateMan;

    /**
     * 建立时间
     */
    @TableField(value = "createdate" , fill = FieldFill.INSERT)
    @DEField(name = "createdate" , preType = DEPredefinedFieldType.CREATEDATE)
    @JsonProperty("createdate")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", locale = "zh", timezone = "GMT+8")
    @JSONField(name = "createdate" , format = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "createdate", notes = "建立时间")
    private Timestamp createDate;

    /**
     * 任务团队
     */
    @TableField(value = "taskteam")
    @DEField(name = "taskteam")
    @JsonProperty("taskteam")
    @JSONField(name = "taskteam")
    @ApiModelProperty(value = "taskteam", notes = "任务团队")
    private String taskteam;



    /**
     * 任务团队
     */
    @JSONField(name = "ibiztaskteams")
    @JsonProperty("ibiztaskteams")
    @TableField(exist = false)
    @ApiModelProperty(value = "ibiztaskteam", notes = "")
    protected List<IBIZTASKTEAM> ibiztaskteam;



    /**
     * 设置 [任务名称]
     */
    public void setIbiztaskName(String ibiztaskName) {
        this.ibiztaskName = ibiztaskName;
        this.modify("ibiztaskname", ibiztaskName);
    }




    /**
     * 设置 [任务团队]
     */
    public void setTaskteam(String taskteam) {
        this.taskteam = taskteam;
        this.modify("taskteam", taskteam);
    }


    

    

    /**
     * 复制当前对象数据到目标对象(粘贴重置)
     * @param targetEntity 目标数据对象
     * @param bIncEmpty  是否包括空值
     * @param <T>
     * @return
     */
    @Override
    public <T> T copyTo(T targetEntity, boolean bIncEmpty) {
        this.reset("ibiztaskid");        
        return super.copyTo(targetEntity, bIncEmpty);
    }    
}