package cn.ibizlab.core.sample.filter;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.*;
import lombok.experimental.Accessors;
import lombok.extern.slf4j.Slf4j;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.alibaba.fastjson.annotation.JSONField;

import org.springframework.util.ObjectUtils;
import org.springframework.util.StringUtils;
import cn.ibizlab.util.filter.QueryWrapperContext;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import cn.ibizlab.core.sample.domain.IBIZCustom;
/**
 * 关系型数据实体[IBIZCustom] 查询条件对象
 */
@Slf4j
@Getter
@Setter
@NoArgsConstructor
@ApiModel("自定义")
public class IBIZCustomSearchContext extends QueryWrapperContext<IBIZCustom> {

    @JsonProperty("n_ibizcustomname_like")
    @JSONField(name = "n_ibizcustomname_like")
    @ApiModelProperty("自定义名称LIKE")
	private String ibizCustomNameLIKE;
	public IBIZCustomSearchContext setIbizCustomNameLIKE(String ibizCustomNameLIKE) {
        this.ibizCustomNameLIKE = ibizCustomNameLIKE;
        if(!ObjectUtils.isEmpty(this.ibizCustomNameLIKE)){
            this.getSearchCond().like("ibizcustomname", ibizCustomNameLIKE);
        }
        return this;
    }
                    
    @JsonProperty("n_ibizcustomid_eq")
    @JSONField(name = "n_ibizcustomid_eq")
    @ApiModelProperty("自定义标识EQ")
	private String ibizCustomIdEQ;
	public IBIZCustomSearchContext setIbizCustomIdEQ(String ibizCustomIdEQ) {
        this.ibizCustomIdEQ = ibizCustomIdEQ;
        if(!ObjectUtils.isEmpty(this.ibizCustomIdEQ)){
            this.getSearchCond().eq("ibizcustomid", ibizCustomIdEQ);
        }
        return this;
    }
                    

    /**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		this.query=query;
		if(!StringUtils.isEmpty(query)){
            this.getSearchCond().and( wrapper ->
                     wrapper.like("ibizcustomname", query)
            );
		}
	}
}