package cn.ibizlab.core.sample.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.Map;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.core.sample.domain.IBIZAPPEXTENDEDITOR;
import cn.ibizlab.core.sample.filter.IBIZAPPEXTENDEDITORSearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.alibaba.fastjson.JSONObject;

public interface IBIZAPPEXTENDEDITORMapper extends BaseMapper<IBIZAPPEXTENDEDITOR> {


    Page<IBIZAPPEXTENDEDITOR> searchDefault(IPage page, @Param("ctx") IBIZAPPEXTENDEDITORSearchContext context, @Param("ew") Wrapper<IBIZAPPEXTENDEDITOR> wrapper);
    List<IBIZAPPEXTENDEDITOR> listDefault(@Param("ctx") IBIZAPPEXTENDEDITORSearchContext context, @Param("ew") Wrapper<IBIZAPPEXTENDEDITOR> wrapper);

    @Override
    IBIZAPPEXTENDEDITOR selectById(Serializable id);

    IBIZAPPEXTENDEDITOR selectEntity(IBIZAPPEXTENDEDITOR entity);

    List<IBIZAPPEXTENDEDITOR> selectEntities(@Param("list") List<IBIZAPPEXTENDEDITOR> list);

    @Override
    int insert(IBIZAPPEXTENDEDITOR entity);

    @Override
    int updateById(@Param(Constants.ENTITY) IBIZAPPEXTENDEDITOR entity);

    @Override
    int update(@Param(Constants.ENTITY) IBIZAPPEXTENDEDITOR entity, @Param("ew") Wrapper<IBIZAPPEXTENDEDITOR> updateWrapper);

    @Override
    int deleteById(Serializable id);

    int deleteEntities(@Param("list") List<IBIZAPPEXTENDEDITOR> list);

    /**
    * 自定义查询SQL
    * @param sql
    * @return
    */
    @Select("${sql}")
    List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);


}