package cn.ibizlab.core.sample.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.Map;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.core.sample.domain.IBIZCustomer_INTF;
import cn.ibizlab.core.sample.filter.IBIZCustomer_INTFSearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.alibaba.fastjson.JSONObject;

public interface IBIZCustomer_INTFMapper extends BaseMapper<IBIZCustomer_INTF> {


    Page<IBIZCustomer_INTF> searchCurCustomer(IPage page, @Param("ctx") IBIZCustomer_INTFSearchContext context, @Param("ew") Wrapper<IBIZCustomer_INTF> wrapper);
    List<IBIZCustomer_INTF> listCurCustomer(@Param("ctx") IBIZCustomer_INTFSearchContext context, @Param("ew") Wrapper<IBIZCustomer_INTF> wrapper);

    Page<IBIZCustomer_INTF> searchDefault(IPage page, @Param("ctx") IBIZCustomer_INTFSearchContext context, @Param("ew") Wrapper<IBIZCustomer_INTF> wrapper);
    List<IBIZCustomer_INTF> listDefault(@Param("ctx") IBIZCustomer_INTFSearchContext context, @Param("ew") Wrapper<IBIZCustomer_INTF> wrapper);

    @Override
    IBIZCustomer_INTF selectById(Serializable id);

    IBIZCustomer_INTF selectEntity(IBIZCustomer_INTF entity);

    List<IBIZCustomer_INTF> selectEntities(@Param("list") List<IBIZCustomer_INTF> list);

    @Override
    int insert(IBIZCustomer_INTF entity);

    @Override
    int updateById(@Param(Constants.ENTITY) IBIZCustomer_INTF entity);

    @Override
    int update(@Param(Constants.ENTITY) IBIZCustomer_INTF entity, @Param("ew") Wrapper<IBIZCustomer_INTF> updateWrapper);

    @Override
    int deleteById(Serializable id);

    int deleteEntities(@Param("list") List<IBIZCustomer_INTF> list);

    /**
    * 自定义查询SQL
    * @param sql
    * @return
    */
    @Select("${sql}")
    List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);


}