package cn.ibizlab.core.sample.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.Map;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.core.sample.domain.IBIZSample0006;
import cn.ibizlab.core.sample.filter.IBIZSample0006SearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.alibaba.fastjson.JSONObject;

public interface IBIZSample0006Mapper extends BaseMapper<IBIZSample0006> {


    Page<IBIZSample0006> searchDefault(IPage page, @Param("ctx") IBIZSample0006SearchContext context, @Param("ew") Wrapper<IBIZSample0006> wrapper);
    List<IBIZSample0006> listDefault(@Param("ctx") IBIZSample0006SearchContext context, @Param("ew") Wrapper<IBIZSample0006> wrapper);

    @Override
    IBIZSample0006 selectById(Serializable id);

    IBIZSample0006 selectEntity(IBIZSample0006 entity);

    List<IBIZSample0006> selectEntities(@Param("list") List<IBIZSample0006> list);

    @Override
    int insert(IBIZSample0006 entity);

    @Override
    int updateById(@Param(Constants.ENTITY) IBIZSample0006 entity);

    @Override
    int update(@Param(Constants.ENTITY) IBIZSample0006 entity, @Param("ew") Wrapper<IBIZSample0006> updateWrapper);

    @Override
    int deleteById(Serializable id);

    int deleteEntities(@Param("list") List<IBIZSample0006> list);

    /**
    * 自定义查询SQL
    * @param sql
    * @return
    */
    @Select("${sql}")
    List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);


}