package cn.ibizlab.core.sample.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.Map;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.core.sample.domain.IBIZSample0007;
import cn.ibizlab.core.sample.filter.IBIZSample0007SearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.alibaba.fastjson.JSONObject;

public interface IBIZSample0007Mapper extends BaseMapper<IBIZSample0007> {


    Page<IBIZSample0007> searchCurGw(IPage page, @Param("ctx") IBIZSample0007SearchContext context, @Param("ew") Wrapper<IBIZSample0007> wrapper);
    List<IBIZSample0007> listCurGw(@Param("ctx") IBIZSample0007SearchContext context, @Param("ew") Wrapper<IBIZSample0007> wrapper);

    Page<IBIZSample0007> searchDefault(IPage page, @Param("ctx") IBIZSample0007SearchContext context, @Param("ew") Wrapper<IBIZSample0007> wrapper);
    List<IBIZSample0007> listDefault(@Param("ctx") IBIZSample0007SearchContext context, @Param("ew") Wrapper<IBIZSample0007> wrapper);

    @Override
    IBIZSample0007 selectById(Serializable id);

    IBIZSample0007 selectEntity(IBIZSample0007 entity);

    List<IBIZSample0007> selectEntities(@Param("list") List<IBIZSample0007> list);

    @Override
    int insert(IBIZSample0007 entity);

    @Override
    int updateById(@Param(Constants.ENTITY) IBIZSample0007 entity);

    @Override
    int update(@Param(Constants.ENTITY) IBIZSample0007 entity, @Param("ew") Wrapper<IBIZSample0007> updateWrapper);

    @Override
    int deleteById(Serializable id);

    int deleteEntities(@Param("list") List<IBIZSample0007> list);

    /**
    * 自定义查询SQL
    * @param sql
    * @return
    */
    @Select("${sql}")
    List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<IBIZSample0007> selectByIbizSample0006Id(@Param("ibizSample0006Id") Serializable ibizSample0006Id);

}