package cn.ibizlab.core.sample.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.Map;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.core.sample.domain.IBIZSample0014;
import cn.ibizlab.core.sample.filter.IBIZSample0014SearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.alibaba.fastjson.JSONObject;

public interface IBIZSample0014Mapper extends BaseMapper<IBIZSample0014> {


    Page<IBIZSample0014> searchCurIbizSample0014(IPage page, @Param("ctx") IBIZSample0014SearchContext context, @Param("ew") Wrapper<IBIZSample0014> wrapper);
    List<IBIZSample0014> listCurIbizSample0014(@Param("ctx") IBIZSample0014SearchContext context, @Param("ew") Wrapper<IBIZSample0014> wrapper);

    Page<IBIZSample0014> searchDefault(IPage page, @Param("ctx") IBIZSample0014SearchContext context, @Param("ew") Wrapper<IBIZSample0014> wrapper);
    List<IBIZSample0014> listDefault(@Param("ctx") IBIZSample0014SearchContext context, @Param("ew") Wrapper<IBIZSample0014> wrapper);

    @Override
    IBIZSample0014 selectById(Serializable id);

    IBIZSample0014 selectEntity(IBIZSample0014 entity);

    List<IBIZSample0014> selectEntities(@Param("list") List<IBIZSample0014> list);

    @Override
    int insert(IBIZSample0014 entity);

    @Override
    int updateById(@Param(Constants.ENTITY) IBIZSample0014 entity);

    @Override
    int update(@Param(Constants.ENTITY) IBIZSample0014 entity, @Param("ew") Wrapper<IBIZSample0014> updateWrapper);

    @Override
    int deleteById(Serializable id);

    int deleteEntities(@Param("list") List<IBIZSample0014> list);

    /**
    * 自定义查询SQL
    * @param sql
    * @return
    */
    @Select("${sql}")
    List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);

    List<IBIZSample0014> selectByIbizsample0003Id(@Param("ibizsample0003Id") Serializable ibizsample0003Id);

}