package cn.ibizlab.core.sample.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.Map;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.core.sample.domain.IBIZSample0017;
import cn.ibizlab.core.sample.filter.IBIZSample0017SearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.alibaba.fastjson.JSONObject;

public interface IBIZSample0017Mapper extends BaseMapper<IBIZSample0017> {


    Page<IBIZSample0017> searchDefault(IPage page, @Param("ctx") IBIZSample0017SearchContext context, @Param("ew") Wrapper<IBIZSample0017> wrapper);
    List<IBIZSample0017> listDefault(@Param("ctx") IBIZSample0017SearchContext context, @Param("ew") Wrapper<IBIZSample0017> wrapper);

    @Override
    IBIZSample0017 selectById(Serializable id);

    IBIZSample0017 selectEntity(IBIZSample0017 entity);

    List<IBIZSample0017> selectEntities(@Param("list") List<IBIZSample0017> list);

    @Override
    int insert(IBIZSample0017 entity);

    @Override
    int updateById(@Param(Constants.ENTITY) IBIZSample0017 entity);

    @Override
    int update(@Param(Constants.ENTITY) IBIZSample0017 entity, @Param("ew") Wrapper<IBIZSample0017> updateWrapper);

    @Override
    int deleteById(Serializable id);

    int deleteEntities(@Param("list") List<IBIZSample0017> list);

    /**
    * 自定义查询SQL
    * @param sql
    * @return
    */
    @Select("${sql}")
    List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);


}