package cn.ibizlab.core.sample.mapper;

import java.util.List;
import org.apache.ibatis.annotations.*;
import java.util.Map;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import java.util.Map;
import org.apache.ibatis.annotations.Select;
import cn.ibizlab.core.sample.domain.IBIZTASK;
import cn.ibizlab.core.sample.filter.IBIZTASKSearchContext;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.alibaba.fastjson.JSONObject;

public interface IBIZTASKMapper extends BaseMapper<IBIZTASK> {


    Page<IBIZTASK> searchDefault(IPage page, @Param("ctx") IBIZTASKSearchContext context, @Param("ew") Wrapper<IBIZTASK> wrapper);
    List<IBIZTASK> listDefault(@Param("ctx") IBIZTASKSearchContext context, @Param("ew") Wrapper<IBIZTASK> wrapper);

    @Override
    IBIZTASK selectById(Serializable id);

    IBIZTASK selectEntity(IBIZTASK entity);

    List<IBIZTASK> selectEntities(@Param("list") List<IBIZTASK> list);

    @Override
    int insert(IBIZTASK entity);

    @Override
    int updateById(@Param(Constants.ENTITY) IBIZTASK entity);

    @Override
    int update(@Param(Constants.ENTITY) IBIZTASK entity, @Param("ew") Wrapper<IBIZTASK> updateWrapper);

    @Override
    int deleteById(Serializable id);

    int deleteEntities(@Param("list") List<IBIZTASK> list);

    /**
    * 自定义查询SQL
    * @param sql
    * @return
    */
    @Select("${sql}")
    List<JSONObject> selectBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义更新SQL
    * @param sql
    * @return
    */
    @Update("${sql}")
    boolean updateBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义插入SQL
    * @param sql
    * @return
    */
    @Insert("${sql}")
    boolean insertBySQL(@Param("sql") String sql, @Param("et")Map param);

    /**
    * 自定义删除SQL
    * @param sql
    * @return
    */
    @Delete("${sql}")
    boolean deleteBySQL(@Param("sql") String sql, @Param("et")Map param);


}