package cn.ibizlab.demoapi.dto;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.math.BigInteger;
import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;
import java.math.BigDecimal;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import com.alibaba.fastjson.annotation.JSONField;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import cn.ibizlab.util.domain.DTOBase;
import cn.ibizlab.util.domain.DTOClient;
import lombok.*;
import lombok.experimental.Accessors;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * 服务DTO对象[IBIZTASKDTO]
 */
@Getter
@Setter
@NoArgsConstructor
@ApiModel("任务")
public class IBIZTASKDTO extends DTOBase implements Serializable {

	private static final long serialVersionUID = 1L;

    /**
     * 建立时间
     */
    @JsonProperty("createdate")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", locale = "zh", timezone = "GMT+8")
    @JSONField(name = "createdate" , format = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty("建立时间")
    private Timestamp createDate;

    /**
     * 建立人
     */
    @JsonProperty("createman")
    @JSONField(name = "createman")
    @ApiModelProperty("建立人")
    private String createMan;

    /**
     * 任务标识
     */
    @JsonProperty("ibiztaskid")
    @JSONField(name = "ibiztaskid")
    @ApiModelProperty("任务标识")
    private String ibiztaskid;

    /**
     * 任务名称
     */
    @JsonProperty("ibiztaskname")
    @JSONField(name = "ibiztaskname")
    @ApiModelProperty("任务名称")
    private String ibiztaskName;

    /**
     * 任务团队
     */
    @JsonProperty("taskteam")
    @JSONField(name = "taskteam")
    @ApiModelProperty("任务团队")
    private String taskteam;

    /**
     * 更新时间
     */
    @JsonProperty("updatedate")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", locale = "zh", timezone = "GMT+8")
    @JSONField(name = "updatedate" , format = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty("更新时间")
    private Timestamp updateDate;

    /**
     * 更新人
     */
    @JsonProperty("updateman")
    @JSONField(name = "updateman")
    @ApiModelProperty("更新人")
    private String updateMan;


    /**
     * 设置 [任务名称]
     */
    public void setIbiztaskName(String ibiztaskName) {
        this.ibiztaskName = ibiztaskName;
        this.modify("ibiztaskname", ibiztaskName);
    }

    /**
     * 设置 [任务团队]
     */
    public void setTaskteam(String taskteam) {
        this.taskteam = taskteam;
        this.modify("taskteam", taskteam);
    }


}
